import 'package:flutter_test/flutter_test.dart';
import 'package:freerasp/freerasp.dart';

void main() {
  test('Threat enum should contain 11 values', () {
    final threatValuesLength = Threat.values.length;

    expect(threatValuesLength, 11);
  });

  test('Threat enum should match its values index', () {
    const threatValues = Threat.values;

    expect(threatValues[0], Threat.hooks);
    expect(threatValues[1], Threat.debug);
    expect(threatValues[2], Threat.passcode);
    expect(threatValues[3], Threat.deviceId);
    expect(threatValues[4], Threat.simulator);
    expect(threatValues[5], Threat.appIntegrity);
    expect(threatValues[6], Threat.obfuscationIssues);
    expect(threatValues[7], Threat.deviceBinding);
    expect(threatValues[8], Threat.unofficialStore);
    expect(threatValues[9], Threat.privilegedAccess);
    expect(threatValues[10], Threat.secureHardwareNotAvailable);
  });

  test(
    'ThreatX.fromString should return correct Threat enum for '
    'valid String value',
    () {
      expect(ThreatX.fromInt(1268968002), Threat.debug);
      expect(ThreatX.fromInt(209533833), Threat.hooks);
      expect(ThreatX.fromInt(1293399086), Threat.passcode);
      expect(ThreatX.fromInt(1514211414), Threat.deviceId);
      expect(ThreatX.fromInt(477190884), Threat.simulator);
      expect(ThreatX.fromInt(1115787534), Threat.appIntegrity);
      expect(ThreatX.fromInt(1001443554), Threat.obfuscationIssues);
      expect(ThreatX.fromInt(1806586319), Threat.deviceBinding);
      expect(ThreatX.fromInt(629780916), Threat.unofficialStore);
      expect(ThreatX.fromInt(44506749), Threat.privilegedAccess);
      expect(ThreatX.fromInt(1564314755), Threat.secureHardwareNotAvailable);
    },
  );
}
